SystemOrganization addCategory: #'StashShell-Core-Shell'!

PPCompositeParser subclass: #StashArgsParser
	instanceVariableNames: 'options option literal keywordOption'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashArgsParser methodsFor: 'productions' stamp: 'DaleHenrichs 12/9/2010 14:47'!
keywordOption

	^ (($- asParser , #letter asParser plus) flatten , literal optional) plus! !

!StashArgsParser methodsFor: 'productions' stamp: 'DaleHenrichs 12/9/2010 14:47'!
literal

	^ (#word asParser plus) token trim ==> [:token | token value ]! !

!StashArgsParser methodsFor: 'productions' stamp: 'DaleHenrichs 12/9/2010 14:47'!
option

	^ literal plus! !

!StashArgsParser methodsFor: 'productions' stamp: 'DaleHenrichs 12/9/2010 14:47'!
options
	^ (keywordOption optional , option optional , keywordOption optional) optional
		==> [ :optionArray | 
			| flattenedOptions |
			flattenedOptions := OrderedCollection new.
			(optionArray select: [ :each | each ~~ nil ]) do: [ :each | 
				each isArray
					ifTrue: [ 
						(each select: [ :a | a ~~ nil ]) do: [:arg |
							arg isArray 
								ifTrue: [ flattenedOptions addAll: (arg select: [ :a | a ~~ nil ]) ]
								ifFalse: [ flattenedOptions add: arg ] ] ]
					ifFalse: [ flattenedOptions add: each ] ].
			flattenedOptions asArray ]! !

!StashArgsParser methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:47'!
start

	^options end! !

PPCompositeParser subclass: #StashCommandParser
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashCommandParser methodsFor: 'productions' stamp: 'DaleHenrichs 12/9/2010 11:07'!
command

	^(#letter asParser , #word asParser star) token trim ==> [ :token | token value ]! !

!StashCommandParser methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:59'!
start

	^command and! !

Object subclass: #StashCommand
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

StashCommand subclass: #StashBuiltInCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashBuiltInCommand classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:00'!
commandString

	self subclassResponsibility! !

!StashBuiltInCommand classSide methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/9/2010 15:59'!
new

	^(super new)
		command: self commandString; 
		yourself! !

StashBuiltInCommand subclass: #StashHELPCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashHELPCommand classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:00'!
commandString

	^'help'! !

!StashHELPCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/9/2010 15:47'!
executeIn: anEnvironment withArgs: argsString
	| args |
	args := self parser parse: argsString.
	args isPetitFailure
		ifTrue: [ ^ self argsParsingError ].
	args isEmpty
		ifTrue: [ ^ self helpText: anEnvironment ].
	self halt! !

!StashHELPCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:56'!
helpText: anEnvironment
	| stream |
	stream := WriteStream on: String new.
	stream
		nextPutAll: 'Smaltalk shell, version ' , ConfigurationOfStashShell project currentVersion printString;
		cr;
		nextPutAll: 'These shell commands are defined internally.';
		cr;
		nextPutAll: 'Type ''help'' to see this list.';
		cr;
		nextPutAll: 'Type ''help name'' to find out more about the function ''name''.';
		cr;
		nextPutAll: 'Use ''info stash'' to find out more about she shell in general.';
		cr.
	(anEnvironment builtinCommands values asArray sort: [ :a :b | a name <= b name ])
		do: [ :cmd | 
			stream
				cr;
				nextPutAll: cmd usage ].
	^ stream contents! !

!StashHELPCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:42'!
usage

	^'help [functionName]'! !

StashBuiltInCommand subclass: #StashLSCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashLSCommand classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:00'!
commandString

	^'ls'! !

!StashLSCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/9/2010 15:47'!
executeIn: anEnvironment withArgs: argsString

	| args |
	args := self parser parse: argsString.
	args isPetitFailure
		ifTrue: [ ^ self argsParsingError ].
	args isEmpty
		ifTrue: [ 
			^anEnvironment currentWorkingNode listContents ].
	self halt! !

!StashLSCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:42'!
usage

	^'ls'! !

StashBuiltInCommand subclass: #StashMKDIRCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashMKDIRCommand classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:00'!
commandString

	^'mkdir'! !

!StashMKDIRCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/9/2010 16:37'!
executeIn: anEnvironment withArgs: argsString
	| args childNode dirNames argCount argIndex cwd stream first |
	args := self parser parse: argsString.
	args isPetitFailure
		ifTrue: [ ^ self argsParsingError ].
	args isEmpty
		ifTrue: [ 
			stream := WriteStream on: String new.
			stream
				nextPutAll: 'mkdir: missing operand';
				cr;
				nextPutAll: 'mkdir: ' , self usageMessage.
			^ stream contents ].
	dirNames := OrderedCollection new.
	argCount := args size.
	argIndex := 1.
	[ argIndex <= argCount ]
		whileTrue: [ 
			| arg |
			((arg := args at: argIndex) beginsWith: '-')
				ifTrue: [ argIndex := self handleOption: arg for: args at: argIndex ]
				ifFalse: [ 
					dirNames add: arg.
					argIndex := argIndex + 1 ] ].
	cwd := anEnvironment currentWorkingNode.
	stream := WriteStream on: String new.
	first := true.
	dirNames
		do: [ :dirName | 
			(cwd hasChildNamed: dirName)
				ifTrue: [ 
					first
						ifFalse: [ stream cr ].
					first := false.
					stream nextPutAll: 'mkdir: cannot create directory: ' , dirName printString , ': File exists' ]
				ifFalse: [ 
					childNode := (StashChildNode new)
						name: dirName;
						yourself.
					cwd addChild: childNode ] ].
	^ stream contents! !

!StashMKDIRCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:57'!
usage

	^'mkdir [OPTION]... DIRECTORY...'! !

!StashCommand classSide methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/9/2010 14:12'!
command: commandName
	^(self new)
		command: commandName;
		yourself! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:49'!
argsParsingError
	| stream |
	stream := WriteStream on: String new.
	stream
		nextPutAll: 'stash invalid arguments';
		cr;
		nextPutAll: self command , ': ' , self usage.
	^ stream contents! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 13:56'!
command
	^ command! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 13:56'!
command: anObject
	command := anObject! !

!StashCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/9/2010 14:18'!
executeIn: anEnvironment withArgs: args

	self subclassResponsibility! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:28'!
handleOption: arg for: args at: argIndex

	self subclassResponsibility! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:08'!
parser

	^StashArgsParser new! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:41'!
usage

	^self subclassResponsibility! !

!StashCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 15:54'!
usageMessage

	^self usage! !

Object subclass: #StashNode
	instanceVariableNames: 'name parent children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

StashNode subclass: #StashChildNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashNode methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:05'!
addChild: aStashChildNode

	aStashChildNode parent: self.
	self children at: aStashChildNode name put: aStashChildNode.! !

!StashNode methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:32'!
children

	children ifNil: [ children := Dictionary new ].
	^ children! !

!StashNode methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:31'!
children: anObject
	children := anObject! !

!StashNode methodsFor: 'testing' stamp: 'DaleHenrichs 12/9/2010 16:32'!
hasChildNamed: aString

	^self children includesKey: aString! !

!StashNode methodsFor: 'builtIn commands' stamp: 'DaleHenrichs 12/9/2010 16:13'!
listContents
	^self listContents: false! !

!StashNode methodsFor: 'builtIn commands' stamp: 'DaleHenrichs 12/9/2010 16:20'!
listContents: full
	| stream first |
	stream := WriteStream on: String new.
	first := true.
	full
		ifTrue: [ 
			stream nextPutAll: '.'.
			first := false.
			self parent
				ifNotNil: [ 
					stream
						cr;
						nextPutAll: '..' ] ].
	(self children values asArray sort: [ :a :b | a name <= b name ])
		do: [ :child | 
			first
				ifFalse: [ stream cr ].
			stream nextPutAll: child name.
			first := false ].
	^ stream contents! !

!StashNode methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:25'!
name
	^ name! !

!StashNode methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:25'!
name: anObject
	name := anObject! !

!StashNode methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:30'!
parent

	^parent! !

!StashNode methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:30'!
parent: anObject
	parent := anObject! !

StashNode subclass: #StashRootNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashRootNode methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:17'!
name
	^'/'! !

!StashRootNode methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:17'!
parent

	^nil! !

Object subclass: #StashShell
	instanceVariableNames: 'parser promptString builtinCommands executableCommands rootNode currentWorkingNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-Core-Shell'!

!StashShell classSide methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/9/2010 16:44'!
executeScript: shellScript

	^(self new)
		executeScript: shellScript! !

!StashShell methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:01'!
builtinCommands
	builtinCommands
		ifNil: [ 
			builtinCommands := Dictionary new.
			StashBuiltInCommand subclasses do: [ :cmdClass | builtinCommands at: cmdClass commandString asSymbol put: cmdClass new ] ].
	^ builtinCommands! !

!StashShell methodsFor: 'node accessing' stamp: 'DaleHenrichs 12/9/2010 14:29'!
currentWorkingNode
	currentWorkingNode ifNil: [ currentWorkingNode := self rootNode ].
	^ currentWorkingNode! !

!StashShell methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 10:04'!
defaultPromptString

	^ '$ '! !

!StashShell methodsFor: 'initialize-release' stamp: 'DaleHenrichs 12/9/2010 16:47'!
executeScript: shellString
	| input output aCommandString str |
	input := ReadStream on: shellString.
	output := WriteStream on: String new.
	[ input atEnd ]
		whileFalse: [ 
			str := self processCommand: input nextLine.
			str isEmpty
				ifFalse: [ output nextPutAll: str ].
			output cr ].
	^ output contents! !

!StashShell methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 10:41'!
parser

	parser ifNil: [ parser := StashCommandParser new ].
	^parser! !

!StashShell methodsFor: 'evaluation' stamp: 'DaleHenrichs 12/9/2010 15:39'!
processCommand: aCommandString
	"parse and execute the command in aCommandString"

	| result command args executor |
	result := self parser parse: aCommandString.
	result isPetitFailure
		ifTrue: [ ^ 'command parse failure: ' , aCommandString printString ].
	command := result.
	args := (aCommandString copyFrom: result size + 1 to: aCommandString size) withBlanksTrimmed.
	executor := self builtinCommands at: command asSymbol ifAbsent: [ ^ 'The command ' , command printString , ' was not found' ].
	^ executor executeIn: self withArgs: args! !

!StashShell methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 10:04'!
promptString
	"The primary command prompt string, equivalent to $PS1 in a Unix shell"

	^ promptString ifNil: [promptString := self defaultPromptString]
! !

!StashShell methodsFor: 'node accessing' stamp: 'DaleHenrichs 12/9/2010 14:29'!
rootNode
	rootNode ifNil: [ rootNode := StashRootNode new ].
	^ rootNode! !
